;********AES11 MONITOR 'S VARIABLES************************
LCDADDR EQU $7300              ; AES11 LCD ADDRESSS     Y3/
KEYPAD  EQU $7400              ; AES11 KEYPAD ADDRESS   Y4/
SCIDRR  EQU $7500              ; SCI ADDRESS (DS5)   Y5/
			       ; (user to disable 2nd serial port)

DAADRR  EQU $7600              ; DA ADDRESS          Y6/


AES_C   EQU $6040              ; I/O Variable
AES_LC  EQU $6041              ; LCD 's cursor postion

RUNUSP  EQU $6042              ; 7E (op code JMP ) 
AESTX2  EQU $6043              ; reversed for nible byte order address
AESTX3  EQU $6044              ; resevered for low byte order address
			       
BUF1    EQU $6046              ; use in AES11 RUN ROUTINE
BUF2    EQU $6047              ; to store ASCII INPUT of user program
BUF3    EQU $6048              ; when enter from the keypad
BUF4    EQU $6049                 

HDLY    EQU $6050              ;2BYTES ADDRESS (DELAY VALUE USE
			       ;TO GENERATE SQUAVE WAVE AT PA6/OC2)
			       ;DEFAULT 50HZ SQUAVE WAVE (HDLY=2400h)

AUTORFG EQU $6052                ;use to run the program at 100Hex
				 ;immediately upon power up
				 ;1 = run program  0 = run the monitor


TBUFFER EQU $6060

RUN_DF  EQU $100               ; use to run default user program at $100
			       ; (call from the AES11 MONITOR)
			       ; (JSR RUN_DF)


;HC11 I/O REGISTERS AFTER RE-MAPPED

ADCTL       EQU  $6030           ;Analog-Digital Control Register
OPTION      EQU  $6039           ;OPTION register
ADR1        EQU  $6031           ;A/D result register1

PORTA       EQU  $6000
PORTD       EQU  $6008
DDRD        EQU  $6009
SPCR        EQU  $6028
BAUD        EQU  $602B
SCCR1       EQU  $602C
SCCR2       EQU  $602D
SCSR        EQU  $602E
SCDAT       EQU  $602F

TCTL1       EQU $6020
TFLG1       EQU $6023
TMSK1       EQU $6022
RTOC2       EQU $6018

			     
	    ORG $00C4         ;START OF RAM INTTERRUPT VECTORS        
PSCI        RMB  3           ; serial comunication interface (RS232)
PSPI        RMB  3           ; sync serial port
PPAC        RMB  3           ; pulse accumulator input edge
PPACOV      RMB  3           ;   "       "       overflow
PTOF        RMB  3           ; timer overflow
PTIOC45     RMB  3           ; in capt 4 / out comp 5
PTOC4       RMB  3           ; output compare 4
PTOC3       RMB  3           ;   "      "     3
PTOC2       RMB  3           ;   "      "     2
PTOC1       RMB  3           ;   "      "     1
PTIC3       RMB  3           ; input capture  3
PTIC2       RMB  3           ;   "      "     2
PTIC1       RMB  3           ;   "      "     1
PRTI        RMB  3           ; real time interrupt
PIRQ        RMB  3           ; irq
PXIRQ       RMB  3           ; xirq
PSWI        RMB  3
PILLCOP     RMB  3
PCOP        RMB  3
PCMF        RMB  3

SP          EQU  $20
CR          EQU  $0D 
LF          EQU  $0A
ESC         EQU  $1B


TEMPX       EQU  $6FFE          ;
FLAG        EQU  $6FFD
CHECK       EQU  $6FFC          ; USED FOR SUMCHECK
S19FLG      EQU  $6FFB          ; CURRENT LINE IS S9 RECORD
S0FLAG      EQU  $6FFA          ; CURRENT LINE IS S0 RECORD

MONSTACK    EQU  $6FF9
USRSTACK    EQU  $6FF7
**************************************************
STACK       EQU  $6FF6
USTACK      EQU  $6F00          ;
;
	    
	    ORG  $8000
	    JMP  COLD

TRAPP       FCB CR,LF
	    FCB CR,LF
	    FCC  '** ILLEGAL OPCODE TRAP !!! **'
	    FCB CR,LF
	    FCB 0

PROMPT      FCB CR,LF
	    FCC '  AES11 DEBUGGER V1.0 (c) 1996'
	    FCB CR,LF
	    FCB 0
SDONE       FCB CR,LF
	    FCC 'Done...'
	    FCB CR,LF
	    FCB 0
SREADY      FCB CR,LF
	    FCC 'Receive ready...'
	    FCB CR,LF
	    FCB 0
AESTXT      FCB CR,LF
	    FCC '  AES-11 MICROCONTROLLER'
	    FCB CR,LF
	    FCB 0

TRAPP2      FCC  '***ILLEGAL*****'
	    FCC  ' OPCODE TRAP!!'
	    FCB 0



COLD        LDS  #STACK

	    
	    LDAA #$06
	    STAA $103D          ;REMAP I/O REGISTERS (1000h-103Fh)
				;to 6000h-603Fh
				;SETUP BAUDRATE
	    
	    LDAA #$11           ;AES11, 3.6864Mhz
	    STAA BAUD           ;9600B, N,8,1
	    LDAA #$0C
	    STAA SCCR2

	    CLR  FLAG           ;CLR ECCO (BIT 7 ) = ECCO CHARS
	    
	    JSR  INITLCD        ;Initialize AES11 LCD Display

COLD2
	    LDAA #$7E                   ;JMP (OP)
	    LDX  #PSEUDOVECT
	    STX  PSCI+1
	    STAA PSCI
	    STX  PSPI+1
	    STAA PSPI
	    STX  PPAC+1
	    STAA PPAC
	    STX  PPACOV+1
	    STAA PPACOV
	    STX  PTOF+1
	    STAA PTOF
	    STX  PTIOC45+1
	    STAA PTIOC45
	    STX  PTOC4+1
	    STAA PTOC4
	    STX  PTOC3+1
	    STAA PTOC3
	    STX  PTOC2+1
	    STAA PTOC2
	    STX  PTOC1+1
	    STAA PTOC1
	    STX  PTIC3+1
	    STAA PTIC3
	    STX  PTIC2+1
	    STAA PTIC2
	    STX  PTIC1+1
	    STAA PTIC1
	    STX  PRTI+1
	    STAA PRTI
	    STX  PIRQ+1
	    STAA PIRQ
	    STX  PXIRQ+1
	    STAA PXIRQ
	    LDX  #MONSWI
	    STX  PSWI+1
	    STAA PSWI
	    LDX  #MONTRAP
	    STX  PILLCOP+1
	    STAA PILLCOP
	    LDX  #COLD
	    STX  PCOP+1
	    STAA PCOP
	    STX  PCMF+1
	    STAA PCMF
	    CLI

	    JSR  INITAES        ;AES11 's initialization of variables
	    LDX  #AESTXT            
	    JSR  CRTTEXT

	    JSR  AUTO_RUN       

	    JSR  AESMON         ;CALL AESMON to START THE AES11 MONITOR

	    BRA  MON68A

MONSWI      STS  USRSTACK       ;save user program stack
	    LDS  #STACK 
	    BRA  MON68


MONTRAP              
	    STS  USRSTACK
	    LDS  #STACK
	    LDX  #TRAPP         
	    JSR  PRINT          
	    
	    JSR LCDCLS
	    LDX #TRAPP2
	    JSR LCDTEXT
	    LDX #$4
	    JSR SDELAY
	    JMP COLD2           


MON68A      LDX  #PROMPT    ;SWI CALLS MONITOR
	    JSR  PRINT      ;


MON68       JSR  REG1
	    CLR  FLAG

MAIN        
;
;
;
;       codes for the DEBUGGER
;
;       
;
PSEUDOVECT  RTI
;
;
;
;
;***************** AES11 CODES*************************
;JMP Table to AES11 Routines        
;******************************************************        
	ORG $9000
	JMP  LCDCLS             ;jmp to routine to clear the LCD
	JMP  LCDCHAR            ;send char in 6040h to LCD
	JMP  KEYCHAR            ;get ASCII code (equivalent to 0-F key)
	JMP  KEYHEX             ;get HEX code (0-Fh)
	JMP  KEYNUM             ;get numeric code (0-9h)
	JMP  KEYCODE            ;get hardware code (00-13h
	JMP  GETCHRE            ;get char from pc keyboard; char echoes
	JMP  GETCHR             ;get char from pc keyboard; no echo
	JMP  PUTCHR             ;send char in 6040h to the CRT display
	JMP  LEDSON             ;toggle 6 leds on
	JMP  LEDSFF             ;toggle 6 leds off
	JMP  ADPE0              ;perform A/D conversion at PE.0 input
				;and return result in 6040h
	JMP  DAC                ;use value in 6040h and make D/A conversion
	
	JMP CRTTEXT             ;send text to the CRT; use IX
	JMP LCDTEXT             ;send text to the LCD display; use IX also
	
	JMP SETCUR              ;LCD cursor equuals the number in
				;AES_LC ($6041)...(0-31)

	JMP SQWAVE              ;create a 50Hz(default) square wave at PA.6
				;note: to create specified square wave,
				;      poke to these locations:$6050,$6051
	JMP SQWAVFF             ;disable the squave wave at PA.6

	JMP ADTEXT              ;perform A/D conversion PE.0 input
				;the result will be in a floating ascii format
				;number storing at $6060
				;(this is one of the self-test routine)
	
	JMP S19UPLOAD           ;Download S19 records to the board

	JMP SERIAL1             ;Enable serial port 1
	
	JMP SERIAL2             ;Enable serial port 1

	JMP SELF_RUN            


;***********************************************************************
;JMP table to FLOATING POINT ROUTINES        
;see 8-bit MCU Appplications Manual, Motorola, 1995, pg. 323
;for the routines descriptions.  ASCFLT, FLTMUL, etc

	ORG $9050
	JMP ASCFLT              ;ASCII TO FLOAT
	JMP FLTMUL              ;FLOAT MULTIPLY
	JMP FLTADD              ;FLOAT ADDITION
	JMP FLTSUB              ;FLOAT SUBTRACTION
	JMP FLTDIV              ;FLOAT DIVISION
	JMP FLTASC              ;FLOAT TO ASCII
	JMP FLTCMP              ;FLOAT COMPARISION
	JMP UINT2FLT            ;UNSIGNED INTEGER TO FLOAT
	JMP SINT2FLT            ;SIGNED INTEGER TO FLOAT
	JMP FLT2INT             ;FLOAT TO INTEGER
	JMP TFR1TO2             ;TRANSFER FLOATACC#1 TO FLOATACC#2
				;(see AES11 RAM Schematic)
	JMP FLTSQR              ;Take Square Root
	JMP FLTSIN              ;Sine
	JMP FLTCOS              ;Cosine
	JMP FLTTAN              ;Tangent
	JMP DEG2RAD             ;Degree to Radian
	JMP RAD2DEG             ;Radian to Degree
	JMP GETPI               ;Get PI (3.14.....)
;***************************************************************************

DELAY_N PSHX            ;routine to make (IX x 4 x 2 cycles)     
			;one cycle takes 1.085uS on this AES11 Board
L1      DEX             ;4 cycles
	BNE L1          ;2 CYCLES
	PULX
	RTS


;routine to make delay (IX seconds)
; SDELAY uses value in seconds in IX to make a delay
SDELAY  PSHX
	PSHY            ;DELAYS IN SECONDS (IX = NO. OF SECONDS)
	PSHA            ;3.6864MHZ 
	
SD0     LDA #$3         ;65536 x 6 x 3 = aprx. 1 second

SD1     LDY #$C000
SD2     DEY             ;4 CYCLES
	BNE SD2         ;2 CYCLES  ...(65536 x 6) TOTAL
	
	DECA            ;1 CYCLE
	BNE SD1         ;2 CYCLES

	DEX             ;1 CYCLES
	BNE SD0         ;2 CYCLES
	PULA
	PULY
	PULX
	RTS
				
				; write out anything to the address line
SERIAL1 STA   $7500             ; at 7500H will enable serial port 1
	RTS

SERIAL2 STA   $7700             ;write out anything to the device address
				;line at 7700H will enable serial port 2
	RTS

SELF_RUN                        ;this routine will write a
	PSHA                    ;1 into location 6052hex
	LDAA #$1                ;to indicate that there
	STAA $6052              ;is a self starting of the
	PULA                    ;user program at 100hex
	RTS                     ;upon power up the aes11 board



;This routine will make a small delay (40uS)
LCD_DY  PSHX                    ;LCD delay routine
	
	LDX  #$7                ;40uS delay in this loop
L2      DEX                     ;4 cycles
	BNE  L2                 ;2 cycles

	LDAA #$F7               E =1, RS=0
	STAA PORTA
	LDAA #$E7               E = 0, RS=0
	STAA PORTA
	PULX
	RTS                     
	
INITLCD PSHX                    ;routine to initialize the AES11 's LCD
	LDX #$0900              ;DELAYS 15mS
	JSR DELAY_N
	LDAA #$EF               ;1110 1111
	STAA PORTA              * E = 0

	LDAA #$E7               ;1110 0111
	STAA PORTA              * RS = 0, E = 0
	LDAA #$38
	STA  LCDADDR            * ADDRESSING LCD ADDRES        
	LDX  #$00C0            
	JSR  DELAY_N
	JSR  LCD_DY            ;40 uS
	LDAA #$6
	STAA LCDADDR
	JSR  LCD_DY            ;40 uS
	LDAA #$D
	STAA LCDADDR
	JSR  LCD_DY            ;40 uS
	LDAA #$1
	STAA  LCDADDR
	JSR  LCD_DY
	LDX  #$445           
	JSR  DELAY_N
	LDAA #$80
	STAA LCDADDR
	JSR  LCD_DY

	LDAA #$F7           ;1111 0111
	STAA PORTA
	LDAA #$1
	STA  LCDADDR
	JSR  LCD_DY
	LDX  #$450
	JSR  DELAY_N
	LDAA #$80
	STAA LCDADDR
	JSR  LCD_DY
	PULX
	RTS

**********************************************************************
* LCDCLS()
* routine to clear the LCD display and set the cursor to home position
**********************************************************************
LCDCLS  PSHX                    
	PSHA                    
	LDAA #$F7               ;RS = 0; SET FOR LCD INSTRUCTION
	STAA PORTA              ;toggle RS
	LDAA #$1                ;LCD instruction code; 1 = clear RAM
	STA  LCDADDR
	JSR  LCD_DY             ;call local routine to toggle E = 1 to E = 0
	LDX  #$445
	JSR  DELAY_N            ;make some delays
	LDAA #$80               ;value to set LCD to it home position
	STAA LCDADDR            
	JSR  LCD_DY             ;local routine to set E high, and E low
				;to make data valid
	CLR  AES_LC             ;clear AES11 variable which keep track
				;lcd 's cursor position
	PULA
	PULX
	RTS

INITAES PSHA
	PSHB
	CLR  AES_C             
	CLR  AES_LC            ;cursor 's at home position
	STA  SCIDRR            ;DISABLE 2nd SERIAL PORT ON THE AES11 
			       ;SYSTEM (important: a must, inorder
			       ;to for the 1st SERIAL PORT to
			       ;communicate with the PC PORT )
	LDAA #$7E              ;OP-CODE (of JMP)
	STAA RUNUSP 
	LDAA #$01
	STAA AESTX2             
	CLR  AESTX3            ;7E 01 00
			       ;default address to run user program
			       ;inside the AES11 MONITOR
	
	LDD  #$2400            ;DEFAULT TIME VALUE
	STD  HDLY              ;TO GENERATE 50Hz SQUARE WAVE AT PA6/OC2 
	PULB
	PULA
	RTS

GETCHR  PSHA
TCHR    LDAA SCSR              ;AES routine to get character
	BITA #$20              ;from the PC keyboard
	BEQ  TCHR              ;ASCII character will not echo
	LDAA SCDAT             ;on the CRT display
	STAA AES_C             ;character stores in AES_C at ($6030)
	PULA
	RTS


PUTCHR  PSHB                    ;AES routine to send character
PNK     LDAB SCSR               ;in AES_C to the CRT
	BITB #$80
	BEQ  PNK                ;loop until TDRE = 1
	LDAB AES_C
	ANDB #$7F               ;mask parity
	STAB SCDAT              ;send to serial data register
	PULB
	RTS



;AES routine to get character from the PC keyboard
;char will be echo on the CRT via JSR PUTCHR
GETCHRE PSHA
TCHRE   LDAA SCSR              
	BITA #$20              
	BEQ  TCHRE             
	LDAA SCDAT             
	STAA AES_C             
	PULA
	JSR PUTCHR
	RTS

* LCDCHAR
* SUBROUTINE TO SEND ASCII CHARACTER IN AES_C (location $6030)
LCDCHAR PSHX                     
	PSHB
	LDAB #$EF              ; E = 0, RS = 1
	STAB PORTA              

	LDAB AES_C             ;read data in AES_C
	STAB LCDADDR           ;SEND DATA TO THE LATCH
	LDX  #$20
L3      DEX                    ; DELAYS
	BNE  L3

	LDAB #$FF              ; RS = HIGH MEANS DATA INPUT                 
	STAB PORTA             ; E=1, RS=1
	
	
	LDAB #$EF              ; LATCH DATA TO LCD ON THE FALLING EDGE OF E
	STAB PORTA             ; E=0, RS=1      

	LDAB AES_LC            ;
	ADDB #$1               ;update cursor postion
	STAB AES_LC            ;save new cursor postion
	CMPB #$10              ;check if line#2 reached?
	BEQ  YLINE_2
	CMPB #$20              ;end of line#2
	BEQ  LINE_3
	BRA  BL_2

YLINE_2 JSR  SETCUR
	BRA  BL_2

LINE_3  CLR  AES_LC        
	JSR  SETCUR

BL_2    PULB
	PULX
	RTS

SETCUR  PSHX                    ;set the LCD cursor position based
	PSHA                    ;on value in AES_LC
	PSHB
	LDAA AES_LC
	CMPA #$1F               ;check if greater than line#2
	BHI  LINE1              ;yes out of range, set to line#1
	CMPA #$0F               ;check if greater than line#1
	BHI  LINE2              ;yes, cursor postion is in line#2
	ADDA #$80
	BRA  SET

LINE2   ADDA #$B0
	BRA  SET

LINE1   LDAA #$80
	CLR  AES_LC

SET     LDAB #$F7               ;RS = 0; SET FOR LCD INSTRUCTION
	STAB PORTA
	STAA LCDADDR
	JSR  LCD_DY
	PULB
	PULA
	PULX
	RTS


KEYCODE PSHA                 * Polling, return scancode(00-13h)
	STAA KEYPAD          * Clear the keypad latch
P1      LDAA PORTA
	BITA #$1             
	BNE P1               * poll for keypad hit event (falling edge)
	LDAA KEYPAD          * Read DATA
	STAA AES_C           * save scancode(00-13h) 
	PULA                 * note: JUMPER J3 connects to PA0
	RTS


KEYCHAR PSHB                 * get the ASCII code equivalent
*                              to keypad character(0-F)        
*                            * ASCII character sends to the LCD
*                            * and save to AES_C
	PSHX
NKC     JSR KEYCODE          * call local subroutine to read keycode
	LDAB AES_C           * local routine returns code in AES_C
	
	CMPB #$10            * is the 17th key
	BEQ NKC              * yes, ignores it and poll again
	CMPB #$11
	BEQ NKC              * ingores the 18th key
	CMPB #$12
	BEQ NKC              * ignores the 19th key
	CMPB #$13
	BEQ NKC              * ingore the 20th key
	LDX #K_ASCII
	ABX                  * add accumulator B to index Register X
	LDAB 0,X             * get ASCII equivalent data from table
	STAB  AES_C          * save ASCII char
	JSR LCDCHAR          * send to the LCD display via LCDCHAR
	PULX
	PULB
	RTS
K_ASCII FCC '048C159D26AE37BF'

KEYHEX  PSHX
	PSHA
	PSHB
NNKC    JSR KEYCODE          * call local subroutine to read keycode
	LDAA AES_C           * local routine returns code in AES_C
	
	CMPA #$10            * is the 17th key
	BEQ NNKC              * yes, ignores it and poll again
	CMPA #$11
	BEQ NNKC              * ingores the 18th key
	CMPA #$12
	BEQ NNKC              * ignores the 19th key
	CMPA #$13
	BEQ NNKC              * ingore the 20th key
	TAB                   * transfer A to B
	LDX #K_ASCII
	ABX                  * add accumulator B to index Register X
	LDAB 0,X             * get ASCII equivalent data from ASCII table
	STAB AES_C
	JSR LCDCHAR
	LDX #K_HEX
	TAB
	ABX                  
	LDAB 0,X             *get hex data from HEX TABLE
	STAB AES_C           *return answer (hex equivalent of 0-Fh)

	PULB
	PULA
	PULX
	RTS

K_HEX   FCB $0,$4,$8,$C,$1,$5,$9,$D,$2,$6,$A,$E,$3,$7,$B,$F


KEYNUM  PSHA                   *poll a numeric key(0-9)
	PSHB                   *return numeric value (0-9h) in AES_C
	PSHX                   *0-9 appears on the LCD
NM_K    JSR KEYCODE            *subroutine to read scancode (00-13H)
	LDAA AES_C             
	CMPA #$3                
	BEQ NM_K               *ignore C key
	CMPA #$7         
	BEQ NM_K               *ignore D key
	CMPA #$A
	BEQ NM_K               *ignore A key
	CMPA #$B
	BEQ NM_K               *ignore E key
	CMPA #$E
	BEQ NM_K               *ignore B key
	CMPA #$F
	BEQ NM_K               *ignore F key
	CMPA #$10
	BEQ NM_K               *ignore (F1) key
	CMPA #$11
	BEQ NM_K               *ignore (F2) key
	CMPA #$12
	BEQ NM_K               *ignore (F3) key
	CMPA #$13
	BEQ NM_K               *ignore (F4) key
	TAB
	LDX #K_ASCII    
	ABX
	LDAB 0,X              *use table lookup to get ASCII 
	STAB AES_C            *data to be sent to the LCD
	JSR LCDCHAR
	TAB
	LDX #K_HEX            *use hex table lookup
	ABX             
	LDAB 0,X
	STAB AES_C             *final answer in hex (0-9h)
	PULX
	PULB
	PULA
	RTS


;aes11 routine to toggle 6 leds on
LEDSON  PSHA                  *ROUTINE TO TOGGLE LEDS ON (6 LEDS)
	LDAA #$FF
	STAA DDRD             *PORT D FOR OUTPUT
	CLRA
	STAA PORTD            ;toggle PD5,PD4,PD3,PD2  
	STAA PORTA            ;toggle PA5,PA6
	PULA            
	RTS

;aes11 routine to toggle 6 leds off
LEDSFF  PSHA                 
	LDAA #$FF            ;set portD for output port
	STAA DDRD
	LDAA #$FF
	STAA PORTD           ;toggle off PD5,PD4,PD3,PD2
	LDAA #$E7            ;toggle off PA5,PA6
	STAA PORTA
	PULA
	RTS


;Routine to perform A/D converstion        
;on channel 0 (PE0).  Mode= single
;channel; scan 0                            

ADPE0   PSHA
	LDAA #$80               ;load value to use with OPTION register
	STAA OPTION             ;set ADPU bit before A/D conversion
				;can take place
	NOP
	NOP


	CLRA                    ;A/D setup value
				;MULT bit and SCAN bit to 0
				;select Channel 0
	STAA ADCTL              ;Write to A/D register to start 
				;conversion
	NOP

ADF     LDAA ADCTL
	BITA #$80
	BEQ ADF                 ;loop until conversion done (CCF sets)
	
	LDAA ADR1               ;read A/D result
	STAA AES_C              ;save result to memmory for later use
	PULA                    ;restore register
	RTS

TXT255  FCC '255'
	FCB 0
TXT5    FCC '5'
	FCB 0

ADTEXT  
	PSHA
	PSHB
	PSHX

	LDX  #TXT255
	JSR  ASCFLT             
	JSR  TFR1TO2
	LDX  #TXT5
	JSR  ASCFLT
	JSR  FLTDIV
	JSR  TFR1TO2
	CLRA
	STAA $6102
	JSR ADPE0               ;A/D CONVERSION
	LDAA AES_C              ;READ D INPUT
	STAA $6103         
	JSR  UINT2FLT           ;CONVERT D VALUE TO FLOATING POINT
	JSR  FLTMUL             ;D * (5/255)
	PULX
	JSR  FLTASC
	PULB
	PULA
	RTS


;READ VALUE IN AES_C AND MAKE D/A CONVERSION
DAC     PSHA
	LDAA AES_C
	STAA DAADRR             ;make D/A conversion at DAADRR
	PULA
	RTS

;routine setups I/O registers inorder to generate a 50hz square
;wave at PA6/OC2 pin
SQWAVE  PSHX                    
	PSHA
	PSHB
	LDX #SVOC2              ;ADDRESS OF OC2 SERVICE ROUTINE
	LDAA #$7E               ;JMP Op
	STAA PTOC2              
	STX  PTOC2+1            
	CLRA
	CLRB
	STD RTOC2               ;CLEAR OUTPUT COMPARE REGISTER 2
	LDAA #$40               ;OM2:OL2 = 0:1
	STAA TCTL1              ;Setup OC2 to toggle on successful compare
	STAA TFLG1              ;Write a 1 (Clear any pending OC2F)
	STAA TMSK1              ;Enable OC2 interrupts
	PULB
	PULA                    
	PULX
	RTS

;interrupt service routine OC2 for the SQWAVE routine
SVOC2   LDD HDLY                ;GET TIME DELAY FOR 1/2 PERIOD
	ADDD RTOC2              ;ADD DELAY
	STD RTOC2               ;UPDATE OC2 (schedule next edge)
	LDAA #$40               ;clear OC2F
	STAA TFLG1
	RTI

SQWAVFF PSHA
	LDAA TMSK1
	ANDA #$BF
	STAA TMSK1
	LDAA TFLG1
	ANDA #$BF
	STAA TFLG1
	PULA
	RTS

ASCII2HX CMPA #$39
	 BHI SUB37
	 SUBA #$30              ;A contains hex(0-9)
	 RTS
SUB37    SUBA #$37              ;A contains hex (A-F)
	 RTS

HX2ASCII ANDA #$0F              
	 ADDA #$30              ;A contains ASCII equivalent to(0-9)
	 CMPA #$39
	 BHI AD7HEX
	 RTS
AD7HEX   ADDA #$7               ;A contains ASCII equivalent to (A-F)
	 RTS



;subroutine to send text string terminates with 0 to the CRT display
;use X register 

CRTTEXT  PSHX
	 PSHA
CRTN     LDAA 0,X               ;get character and advance pointer
	 BEQ CRTEND             ;0 terminator
	 STAA AES_C             ;save in global AES_C
	 JSR PUTCHR             ;call subroutine PUTCHR to send [AES_C]
	 INX
	 BRA CRTN               ;get next character
CRTEND   PULA
	 PULX
	 RTS

;subroutine to send text string terminates with 0 to the LCD display
;use X register 
LCDTEXT  PSHX 
	 PSHA
LCDN     LDAA 0,X               ;get character and advance pointer
	 BEQ LCDEND             ;character is 0 terminator (end of text)
	 STAA AES_C             ;save in AES_C
	 JSR LCDCHAR            ;subroutine to send [AES_C] to the LCD
	 INX                    ;advance pointer
	 BRA LCDN               ;get next character
LCDEND   PULA
	 PULX
	 RTS


AESPRMPT    FCC  ' AES-11 MONITOR '
	    FCC  ' SYSTEM READY!'
	    FCB  0

;**********************************************************
;***MAIN CODES TO START THE AES11 MONITOR***
;**********************************************************

AUTO_RUN
	    PSHA
	    LDAA AUTORFG       ;read the byte at 6052hex
	    CMPA #$01        ;check for self running program
	    BEQ S_START
	    PULA
	    RTS

S_START
	    JMP $100          ;jump to program stored at $100
			       ;and run


AESMON      PSHY
	    PSHX
	    PSHA
	    PSHB
	    
MAINTEXT    JSR  LCDCLS
	    LDX  #AESPRMPT              
	    JSR  LCDTEXT                ;DISPLAY GREETING MESSAGE ON THE LCD
	    JSR  LEDSFF                 ;Toggle LEDS OFF

AESMAIN     JSR  KEYCODE                ;routine to get keycode (00-13h)
	    LDAA AES_C                  ;read keycode
	    CMPA #$10                   ;is the ESC KEY pressed?
	    BEQ  K_ESC                  ;perform ESC KEY ROUTINE
	    CMPA #$11
	    BEQ  K_TEST
	    CMPA #$12
	    BEQ  K_RUN
	    CMPA #$13
	    BEQ  K_FUNC
	    BRA  AESMAIN                ;POLL FOR A KEY PRESSED AGAIN

K_ESC   
	JSR ESCPROC
	JMP AESMONX                     ;EXIT AES11 MONITOR
					;AND RETURN TO AES11 DEBUGGER
K_TEST  
	JSR TESTPROC
	BRA MAINTEXT

K_RUN   
	JSR RUNPROC
	BRA MAINTEXT

K_FUNC  
	JSR FUNCPROC
	BRA MAINTEXT          



RUNPROC JSR LCDCLS              ; 
	LDX #RUNTXT
	JSR LCDTEXT
	LDA #$19               ;[0100]
	STAA AES_LC            ; ^19h
	JSR SETCUR
	
RN      JSR KEYCODE
	LDAA AES_C
	CMPA #$12             ;is RUN KEY hit again to
	BEQ RUNDF             ;run user program at $0100
	CMPA #$10             ;ESC KEY HIT (cancel default program)
	BEQ NORUN
	CMPA #$11
	BEQ  RN               ;IGNORE TEST-KEY
	CMPA #$13
	BEQ  RN               ;IGNORE FUNC. KEY
	JMP  GETADDR          ;HERE THE USER ENTER NEW ADDRESS
			      ;FOR A SUB-PROGRAM

NORUN   RTS                   ;RTS RUNPROC
	
RUNDF   JSR LCDCLS
	LDX #RUN1TXT          ;Running....
	JSR LCDTEXT
	LDX #$FFFF
	JSR DELAY_N
	JSR DELAY_N
	JSR DELAY_N
	JSR DELAY_N
	JSR DELAY_N
	JSR RUN_DF            ;JSR $100 and start the code 
	JSR LCDCLS            
	LDX #FRUNTXT          ;Ends user program
	JSR LCDTEXT
	JSR KEYCODE
	RTS                   ;RTS RUN PROC  



GETADDR LDY  #BUF1            ;1st byte location in an array
	LDAB AES_C            ;get 1st input through previous call
	LDX #K_ASC2           ;input in hex will convert to ASCII input
	ABX                   
	LDAB 0,X              ;conversion is from table up
	STAB AES_C              
	STAB 0,Y               ;store 1st byte of input into the array
	INY
	JSR LCDCHAR            ;1st input byte in ASCII format
			       ;is sent to the LCD 
	
	LDAA #$3               ;COUNTer for THE LAST 3 INPUT (2nd,3rd,4th)

GETNX   JSR KEYCODE           ;get sub sequence input (2nd,3rd,4th)
	LDAB AES_C
	CMPB #$10             ;ESC KEY HIT (re-enter input)
	BEQ  RUNPROC          ;redisplay input format ([0100])
	CMPB #$11             
	BEQ GETNX             ;ignore TEST KEY
	CMPB #$13
	BEQ GETNX             ;ingore FUNC. KEY
	CMPB #$12
	BEQ GETNX             ;ingore RUN KEY


	LDX #K_ASC2           ;2nd, 3nd, 4th input 
	LDAB AES_C            ;again input in HEX format  
	ABX
	LDAB 0,X
	STAB AES_C
	STAB 0,Y
	INY
	JSR LCDCHAR
	DECA                  ;is last input (4th) reached?
	BNE GETNX

			 ;USER HAD ENTER FULL 4 BYTES OF ASCII INPUT
			 ;AND SAVE IN MEMMORY (BUF1,BUF2,BUF3,BUF4)
	CLR AES_LC
	JSR SETCUR       ;home the cursor to display
	LDX #RUNRDY      ;RUN READY!
	JSR LCDTEXT
	
LINPUT  JSR KEYCODE      ;up to this point, user could run
	LDAB AES_C       ;the user program or re enter all 
	CMPB #$10        ;4 bytes of input
	BEQ LRUNPROC
	CMPB #$12        ;this loop (LINPUT) ignore other keys except
	BEQ TRANSLATE    ;ESC KEY, RUN KEY
	BRA LINPUT

RUNRDY  FCC 'PROGRAM READY! '
	FCB 0

LRUNPROC JMP RUNPROC    ;HANDLE BRANCH OUT OF RANGE
K_ASC2 FCC '048C159D26AE37BF'

TRANSLATE                       ;sub routine to translate
				;4 ASCII BYTES entered from
				;the keypad to actual machine 
				;instructions (JMP $xxxx)

	LDAA BUF1               ;CONVERT ASCII TO HEX INPUT FIRST
	JSR ASCII2HX
	STAA BUF1
	
	LDAA BUF2
	JSR ASCII2HX
	STAA BUF2

	LDAA BUF3
	JSR ASCII2HX
	STAA BUF3

	LDAA BUF4
	JSR ASCII2HX
	STAA BUF4

				;MERGING 2 BYTES INTO 1 BYTE
				;BUF1 & BUF2 ->> AESTX2
				;BUF3 & BUF4 into AESTX3
	LDAA BUF1
	ASLA
	ASLA
	ASLA
	ASLA
	ADDA BUF2
	STAA AESTX2
	
	LDAA BUF3
	ASLA
	ASLA
	ASLA
	ASLA
	ADDA BUF4
	STAA AESTX3

	JSR LCDCLS
	LDX #RUN1TXT          ;Running....
	JSR LCDTEXT
	LDX #$FFFF
	JSR DELAY_N
	JSR DELAY_N
	JSR DELAY_N
	JSR DELAY_N
	JSR RUNUSP            ;JSR $100 and start the code 
	JSR LCDCLS            
	LDX #FRUNTXT          ;Ends user program
	JSR LCDTEXT
	JSR KEYCODE

	RTS



;start of FUNC ROUTINE
;in this routine, user can download S19 Hex file
;from the host machine. After download file, subroutine
;returns to AES11 MONITOR 'S MAIN LOOP

FUNCPROC JSR LCDCLS             
	 LDX #PRGTXT            ;DOWNLOAD PROMPT
	 JSR LCDTEXT            ;SEND to LCD
	 
FKCHAR   JSR KEYCODE            ;after the DOWNLOAD PROMPT,
	 LDAA AES_C             ;trap for ESC KEY or FUNC key
	 CMPA #$10              ;ESC KEY (cancel host download)
	 BEQ  FPROC1            ;
	 CMPA #$13
	 BEQ  FPROC2            ;OK to start DOWNLOAD
	 BRA  FKCHAR            ;if not (FUNC KEY or ESC) poll new key

FPROC1   JSR  LCDCLS            ;user doesn't want to download S19
	 LDX #PRGTXT2           ;cancel message
	 JSR LCDTEXT
	 LDX #$1
	 JSR SDELAY
				;pause (any key hit)
	 RTS                    ;exit from FUNC SUBROUTINE

FPROC2   JSR LCDCLS
	 LDX #PRGTXT3           ;Receive ready....
	 JSR LCDTEXT
	 JSR S19UPLOAD          ;Receiving S19 records...
	 LDX #PRGTXT4
	 JSR LCDTEXT            ;Done receive S19 records
	 JSR KEYCODE            ;pause
	 RTS                    ;exit from FUNC SUBROUTINE
	 

AESMONX     PULB                ;AESMON POINT OF EXIT
	    PULA
	    PULX
	    PULY
	    RTS

PRGTXT   FCC '-HOST DOWNLOAD- '
	 FCC 'Motorola S19 HEX'
	 FCB  0

PRGTXT2  FCC '-HOST DOWNLOAD- '
	 FCC '    CANCEL      '
	 FCB 0

PRGTXT3  FCC 'Receive ready...'
	 FCB 0

PRGTXT4  FCC 'Done...'
	 FCB 0

RUNTXT  FCC  'RUN SUB-PROGRAM '    
	FCC  'ADDRESS:[0100]h'
	FCB  0             

RUN1TXT  FCC 'Running...'
	 FCB 0
FRUNTXT  FCC 'ENDS SUB-PROGRAM'
	 FCB 0


TESTPROC JSR LCDCLS
	 LDX #TESTMNU
	 JSR LCDTEXT
	 
TESTNK   JSR KEYCODE            ;GET TEST #
	 LDAA AES_C
	 CMPA #$10
	 BEQ  TESTESC           ;CANCEL TEST ROUTINE
	 CMPA #$11
	 BEQ  TESTNK            ;IGNORE TEST KEY
	 CMPA #$12
	 BEQ  TESTNK            ;IGNORE RUN KEY
	 CMPA #$13              
	 BEQ  TESTNK            ;IGNORE FUNC. KEY
	 CMPA #$4               ;'1' KEY HIT
	 BEQ  T1PERF            ;BRANCH AND PERFORM TEST#1 (LEDS ON/OFF)
	 CMPA #$8               ;'2' KEY HIT
	 BEQ  T2PERF            ;BRANCH AND PERFORM SERIAL 1 TEST
	 CMPA #$C               ;'3' KEY
	 BEQ  T3PERF            ;BRANCH AND PERFORM A/D TEST 
	 CMPA #$1               ;'4' KEY
	 BEQ  T4PERF            ;D/A TEST

	 BRA  TESTNK


TESTESC  RTS                    ;exit MAIN TEST ROUTINE 

T3PERF   JSR T3PERFB            ;routine to perform TEST '3' (A/D) 
	 JMP TESTPROC 

T4PERF   JSR T4PERFB
	 JMP TESTPROC

T1PERF  LDAA #'1'               
	STAA AES_C
	JSR LCDCHAR
	LDX #$1
	JSR SDELAY
	JSR LCDCLS              ;TEST 1.  LEDS ON THEN LEDS OFF
	LDX #T1TXT
	JSR LCDTEXT
	JSR LEDSON
	LDX #$1
	JSR SDELAY
	JSR LCDCLS 
	LDX #T1TXTB
	JSR LCDTEXT
	JSR LEDSFF
	LDX #$1
	JSR SDELAY
	JMP TESTPROC
T1TXT    FCC 'LEDS ON!!'
	 FCB 0
T1TXTB   FCC 'LEDS OFF!!'
	 FCB 0

T2PERF  LDAA #'2'
	STAA AES_C
	JSR LCDCHAR
	LDX #$1
	JSR SDELAY
	JSR LCDCLS
	LDX #T2TXT
	JSR LCDTEXT
	LDX #T2STRNG
	JSR CRTTEXT
	LDA #$10
	STAA AES_LC
	JSR SETCUR
	LDX #T2TXTB
	JSR LCDTEXT
	LDX #$1
	JSR SDELAY
	JMP TESTPROC 


T2STRNG FCB 10,13  
	FCC 'AES TEST STRING'
	FCB 7                           ;a beep 
	FCB 10,13
	FCB 0

T2TXT    FCC 'SERIAL 1 TEST'
	 FCB 0 
T2TXTB   FCC 'TEST DONE...'
	 FCB 0 

TESTMNU  FCC 'AES-11 TEST MENU'
	 FCC '<Test #?> '
	 FCB 0

T3PERFB LDAA #'3'
	STAA AES_C      
	JSR LCDCHAR
	LDX #$1
	JSR SDELAY
	JSR LCDCLS
	LDX #T3TXT              
	JSR LCDTEXT
	LDX #TBUFFER            
	JSR ADTEXT
	JSR LCDTEXT
	LDX #T3RST
	JSR LCDTEXT
	LDX #$1
	JSR SDELAY

	RTS 

T3TXT   FCC 'A/D CONVERSION '
	FCB 0
T3RST   FCC ' Volts'
	FCB 0

T4PERFB LDAA #'4'
	STAA AES_C
	JSR LCDCHAR             ;DISPLAY '4' TO INDICATE TEST #4
	LDX #$1
	JSR SDELAY              ;SDELAY DELAYS 2 SECONDS
	JSR LCDCLS
	LDX #T4TXT              
	JSR LCDTEXT             ;D/A CONVERSION PROMPT

	JSR KEYHEX
	LDAB AES_C              ;4 MOST SIGNIFICANT BITS OF D INPUT
	JSR KEYHEX
	LDAA AES_C              ;4 LEAST SIGNIFICANT BITS OF D INPUT
	LSLB
	LSLB
	LSLB
	LSLB
	ABA                     ;FINAL FORMAT OF D INPUT TO BE CONVERTED
	TAB                     ;TRANSFER TO B (WILL USE IT LATER!)
	LDAA #'H'
	STAA AES_C
	JSR LCDCHAR
	CLR AES_LC
	JSR SETCUR
	LDX #T4TXT2             ;READY TO RUN D/A TEST
	JSR LCDTEXT
T4TK    JSR KEYCODE
	LDAA AES_C
	CMPA #$10               ;ESC KEY (CANCEL D/A TEST)
	BEQ T4CNCL
	CMPA #$12
	BEQ DAT4OK              ;OK TO START D/A 
	BRA T4TK


T4CNCL  JSR LCDCLS
	LDX #T4TXT3              ;-TEST CANCEL;
	JSR LCDTEXT
	LDX #$1
	JSR SDELAY
	RTS                     ;RTS T4PERFB

DAT4OK  TBA                     
	STAA AES_C
	JSR DAC
	JSR LCDCLS
	LDX #T4TXT4             ;CONVERSION ENDS'
	JSR LCDTEXT
	LDX #$1
	JSR SDELAY
	RTS                     ;RTS T4PERFB


T4TXT   FCC 'D/A CONVERSION  '
	FCC 'D INPUT = '
	FCB 0
T4TXT2  FCC 'READY TO RUN!  '
	FCB 0
T4TXT3  FCC '-TEST CANCEL-'
	FCB 0
T4TXT4  FCC 'CONVERSION DONE'
	FCB 0

ESCPROC JSR LCDCLS
	LDX #ESCTXT
	JSR LCDTEXT
	LDX #1
	JSR SDELAY
	JSR LCDCLS
	LDX #DEGTXT
	JSR LCDTEXT
ESK     JSR KEYCODE
	LDAA AES_C
	CMPA #$0        
	BEQ DEBUGG      
	CMPA #$4
	BEQ BASIC
	BRA ESK
	RTS           

ESCTXT  FCC ' MONITOR EXITS!'
	FCB 0
DEGTXT  FCC '0 = DEBUGGER    '
	FCC '1 = BASIC11   '
	FCB 0

DEBUGG  LDA #'0'
	STAA AES_C
	JSR LCDCHAR
	LDX #$1
	JSR SDELAY
	JSR LCDCLS
	LDX #DTXT
	JSR LCDTEXT
	RTS
DTXT    FCC 'DEBUGGER Ver 1.0'
	FCB 0
BASIC   LDA #'1'
	STAA AES_C
	JSR LCDCHAR
	LDX #$1
	JSR SDELAY
	JSR LCDCLS
	LDX #BTXT
	JSR LCDTEXT
	JMP $ED77
	RTS

BTXT    FCC 'BASIC11 v1.55   '
	FCB 0

;
;        
; codes for floating point packages
;
;
;

**********HARDWARE VECTORS*******************
	    
	    ORG  $FFD6
SCI         FDB  PSCI           ;FFD6 FFD7
SPI         FDB  PSPI           ;FFD8 FFD9
PACC        FDB  PPAC           ;FFDA FFDB
PACCOV      FDB  PPACOV         ;FFDC FFDD
TOVF        FDB  PTOF           ;FFDE FFDF
TIOC45      FDB  PTIOC45        ;FFE0 FFE1
TOC4        FDB  PTOC4          ;FFE2 FFE3
TOC3        FDB  PTOC3          ;FFE4 FFE5
TOC2        FDB  PTOC2          ;FFE6 FFE7
TOC1        FDB  PTOC1          ;FFE8 FFE9
TIC3        FDB  PTIC3          ;FFEA FFEB
TIC2        FDB  PTIC2          ;FFEC FFED
TIC1        FDB  PTIC1          ;FFEE FFEF
RTI         FDB  PRTI           ;FFF0 FFF1
IRQ         FDB  PIRQ           ;FFF2 FFF3
XIRQ        FDB  PXIRQ          ;FFF4 FFF5
	    
	    
	    ORG  $FFF6
SWI         FDB  PSWI          ;FFF6 FFF7
TRAP        FDB  PILLCOP       ;FFF8 FFF9
COP         FDB  PCOP          ;FFFA FFFB
COP1        FDB  PCMF          ;FFFC FFFD
RESET       FDB  $8000         ;FFFE FFFF 
	    END
