;50HZ.ASM (AES11 PROGRAM)
;Generate a 50Hz square wave at PA.6 (PA6/OC2 pin)
;A 50Hz square wave take 20mS in one period, which means the wave
;must be up for 10mS and down for 10mS.

;NOTE: program doesn't use interrupt service routine for 
;      Output Comparator Timer 2. 
;      

;Assembler: AS11 Ver. 1.03
;AS11.EXE 50HZ.ASM
;To run program at the debugger prompt:
;B 0100 
        
        ORG     $100            ;program starts at 100H

        LDX     #$6000          ;BASE ADDRESS OF I/O REGISTER
        
                                ;load A-accumulator with 40Hex 
        LDAA    #$40            ;Set OM2 flag and OL2 flag in TCLT1 register
                                ;to 01 so PA.6 will toggle one pulse
                                ;on successful compare
        
        STAA    $20,X           ;write 40Hex into TCLT1 register
                                ;TCLT1 register is at 6020H
                                ;STAA $20,X     ;index addressing mode


LOOP1   LDAA    #$40            ;Clear OC2F flag in TFLG1 register
        STAA    $23,X           ;at $6023 by writing a 1 in the 
                                ;corresponding bit position (bit OC2F)

LOOP2   BRCLR   $23,X #$40  LOOP2           
                                
                                ;wait until OC2F = 1
                                ;This will toggle the output (one pulse)

        LDD     $18,X           ;Get count in TOC2 register
        ADDD    #$2400          ;Add 10mS (1.085uS/cycle * 2400H cycles)
        STD     $18,X           ;Store in TOC2 (schedule next edge)

        BRA     LOOP1           ;loop to make a 50Hz wave


