;ADPE0.ASM (AES11 PROGRAM)
;Routine to perform A/D conversion on analog input connects to PE.0      
;Mode= single channel, scan 0

;Analog Input = D * Resolution
;Resolution = VRh-VRl /(2^8) = Apx. 19.37mV on the AES11 Board

;Assembler: AS11 Ver. 1.03
;AS11.EXE ADPE0.ASM
;From the debugger menu:
;B 0100 

OPTION  EQU     $6039           ;System Configuration Option Register
ADCTL   EQU     $6030           ;A/D Control Register
ADR1    EQU     $6031           ;A/D Result Register 1

        ORG    $100
        PSHA

        LDAA #$80               ;value to use with OPTION register
        STAA OPTION             ;set ADPU bit before A/D conversion
                                ;can take place (required)

        CLRA                    ;clear A-accumulator
                                ;A/D setup value
                                ;MULT bit and SCAN bit to 0
                                ;select Channel 0
        
        STAA ADCTL              ;Write to A/D control register to start 
                                ;conversion

ADF     LDAA ADCTL
        BITA #$80
        BEQ ADF                 ;loop until conversion done (CCF Flag sets)
        
        LDAA ADR1               ;read D result 
        STAA RESULT             ;save result to memmory for later use
        
        PULA        
        RTS

        ORG     $200
RESULT  ZMB     1               ;A/D result will be saved here

        
