



;adtest.asm   7-16-97   test of a/d circuits on 68HC11
;THIS CODE IS DESIGNED TO RUN ON THE AES-11

;This is a program  to measure two voltages on PE0 and PE1
;and compare their product (in the D register) with a number NUM1.  
;Depending on whether D is equal to, greater than, or less than NUM1
;one of three LEDs will light up.  The product of the two voltages
;is saved in the location RES1 for some further use if any.  The program
;will run once and return.

;The results in ADR1 and ADR2 are 8 bit numbers from 0 to FF which
;represent 0 to 5 volt inputs on PE0 and PE1.

PORTD   EQU     $6008
ADCTL   EQU     $6030
OPTION  EQU     $6039
ADR1    EQU     $6031   ;STORE PE0 VOLTAGE   
ADR2    EQU     $6032   ;STORE PE1 VOLTAGE
RES1    EQU     $0500   ;STORE 2 BYTE VARIABLE(IN ANY FREE MEMORY SPACE)
NUM1    EQU     $B66A   ;AN ARBITRARY NUMBER TO USE FOR COMPARISON TEST

;The value NUM1 is any number from 0 to FFFF to be specified by you.

        ORG     $0100
        PSHA            ;SAVE A, B  AND X 
        PSHB
        PSHX
        LDAA #$90       ;ADPU=1 TO START A/D SYSTEM, KEEP DLY=1 IN OPTION
        STAA    OPTION
        NOP             ;LITTLE DELAY HERE FOR A/D SYSTEM POWER UP
        NOP
        NOP
        LDAA #$10       ;SET MULT=1 IN ADCTL FOR 4 INPUT PINS IN USE

        STAA ADCTL      ;THIS COMMAND STARTS EACH A/D CONVERSION PROCESS
ADF     LDAA ADCTL      ;LOOP ON CCF BIT IN ADCTL UNTIL CONVERSON DONE
        BITA #$80
        BEQ ADF         ;CONT IF CCF=1, LOOP IF CCF=0
        
;AT THIS POINT THE CONVERSION IS DONE AND THE RESULTS OF THE 4 VOLTAGES
;ON PINS PE0-PE3 ARE IN REGISTERS ADR1-ADR4 RESPECTIVELY.
;PROBABLY SHOULD GROUND PE2 AND PE3 IF NOT USING THEM.

;NOW LETS TAKE THE VOLTAGES ON PINS PE0 AND PE1 AND MULTIPLY THEM.
        LDAA    ADR1   ;MULTIPLY ADR1 * ADR2
        LDAB    ADR2
        MUL             ;RESULT IS IN D REGISTER
        STD     RES1    ;STORE 2 BYTE RESULT IN RES1
        LDX     #PORTD  ;LOAD X REGISTER FOR LATER BCLR INSTRUCTIONS
;NOW COMPARE THE RESULT WITH YOUR CHOSEN NUMBER
        CPD     #NUM1   ;SETS N,Z,V,OR C FLAGS
        BEQ     TEST1   ;GOTO TEST1 IF D=NUM1 , USES Z FLAG
        BCS     TEST2   ;GOTO TEST2 IF D<NUM1 , USES C FLAG
        
;TO GET TO THIS POINT D MUST BE GREATER THAN NUM1
        
        BCLR    0,X $20    ;CLEAR PD5, TURN ON LED ON PD5 (D > NUM1)
        BRA     HOP1
TEST1   BCLR    0,X $10    ;CLEAR PD4, TURN ON LED ON PD4 (D = NUM1)
        BRA     HOP1
TEST2   BCLR    0,X $08    ;CLEAR PD3, TURN ON LED ON PD3 (D < NUM1)
HOP1    LDAA    #$10
        STAA    OPTION         ;TURN OFF THE A/D SYSTEM
        PULX
        PULB                   ;RESTORE A, B AND X
        PULA
        RTS       
