;BLOCK.ASM 
;program reads block of data betwen 1000-10FFH and transfer it to 
;the serial port. Each byte of the data is separated by a blank space.
;a cariage and a line feed will be sent at every 16 bytes

;Assembler: AS11 Ver. 1.03
;Assembler Command Line: AS11 BLOCK.ASM
;
;To run program from the debugger menu:
;B 0100 <enter>

STARTADR EQU  $1000    ;starting address to log data
ENDADR   EQU  $10FF    ;ending address to log data

AES_C    EQU  $6040    ;RAM storage used by ROM routines
PUTCHAR  EQU  $9018    ;address of ROM routine which sends ASCII code in 
                       ;AES_C to the serial port.
        ORG $100
        LDAB #$10       ;count down constant (16)
        LDX #STARTADR
NEXT        
        LDA 0,X         ;read data in memory
        PSHA            ;save on stack for later use again
        LSRA            ;Logical Shift Right 4 times
        LSRA
        LSRA
        LSRA            
        JSR   HX2ASCII  ;converts the high nible to ASCII
        STA   AES_C
        JSR   PUTCHAR
        PULA
        ANDA #$0F       ;strip the high nible 
        JSR  HX2ASCII   ;converts the lower nible to ASCII
        STA  AES_C
        JSR  PUTCHAR
        JSR  SPACE
        DECB
        BEQ   LINE      ;if 16 bytes sent, go and send a newline
CONT
        INX
        CPX  #ENDADR+1
        BNE  NEXT
        RTS             ;return to the DEBUGGER via B 0100 <CR>

LINE    JSR NEWLINE
        LDAB #$10
        BRA CONT


;routine to convert hexadecial (0-Fhex) in A-register to the 
;equivalent ASCII code
HX2ASCII ANDA #$0F              
         ADDA #$30      ;A contains ASCII equivalent to(0-9Hex)
         CMPA #$39
         BHI AD7HEX
         RTS
AD7HEX   ADDA #$7       ;A contains ASCII equivalent to (A-FHex)
         RTS

SPACE    PSHA
         LDAA #$20      
         STA AES_C
         JSR PUTCHAR
         PULA
         RTS

NEWLINE  PSHA
         LDAA #$0A
         STA AES_C
         JSR PUTCHAR
         LDAA #$0D
         STA AES_C
         JSR PUTCHAR
         PULA
         RTS
         END
