;FLOAT.ASM
;This program multiplies two floating points

;Assembler: AS11 Ver. 1.03
;Assembler Commands: AS11 FLOAT.ASM
;
;To run program at the Debugger Prompt, type
;B 0100 <enter>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ADDESSES OF FLOATING ROUTINES IN ROM
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

ASCFLT  EQU  $9050              ;ASCII TO FLOAT CONVERSION
FLTMUL  EQU  $9053              ;FLOATING MULTIPLY
FLTASC  EQU  $905F              ;FLOATING POINT TO ASCII CONVERSION
TFR1TO2 EQU $906E               ;Transfer FACC1 to FACC2

;*********************************************************************

CRTTEXT EQU  $9027        ;ADDRESS OF AES ROUTINE WHICH SENDS TEXT STRING
                          ;TO THE CRT DISPLAY using 1st serial port.
        
        ORG $100                
        JMP MAIN               


BUFFER  ZMB 14                 ;reserved 14 BYTES 

X       FCC '-1.343E-2'        ;1st floating point in ascii format
        FCB 0

Y       FCC '-10000'           ;2nd floating point in ascii format
        FCB 0

        ORG $200                
MAIN                           ;main codes start 
        
        LDX  #X                ;IX points to X
        JSR  ASCFLT            ;CONVERT 1ST ASCII TO FLOAT ACCUMULATOR#1

        JSR  TFR1TO2           ;Transfer Float Accumulator#1 to Float
                               ;Accumulator #2
        
        LDX  #Y                ;IX points to 2nd floating point
        JSR  ASCFLT            ;convert to floating-point format

        JSR  FLTMUL            ;multiply X and Y together
                               ;result is in Float Accumulator#1
        
        LDX  #BUFFER           
        JSR  FLTASC            ;convert the result in float format
                               ;to ascii format and store in BUFFER

        LDX  #BUFFER
        JSR  CRTTEXT           ;send result to the CRT display
        
        RTS                    ;program ends; returns from B 0100

        END
