;FLOAT1.ASM (AES11 Sample Program)

;Program uses the floating-point routines in ROM to multiply two numbers.
;The result will be displayed on the CRT and the LCD.

;Assembler: AS11 Ver. 1.03
;Assembler Commands: AS11 FLOAT.ASM
;
;To run program at the Debugger Prompt, type
;B 0100 <enter>


; Assembler 's Directives (EQU's, ORG's)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ADDRESSES OF FLOATING ROUTINES IN ROM.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
ASCFLT  EQU  $9050              ;ASCII TO FLOAT CONVERSION
FLTMUL  EQU  $9053              ;FLOATING MULTIPLY
FLTASC  EQU  $905F              ;FLOATING POINT TO ASCII CONVERSION
TFR1TO2 EQU  $906E              ;Transfer FACC1 to FACC2


;*********************************************************************

CRTTEXT EQU  $9027              ;ADDRESS OF AES ROUTINE WHICH SEND TEXT
                                ;STRING TO THE CRT DISPLAY.

LCDCLS  EQU  $9000              ;ADDRESS OF AES ROUTINE WHICH CLEAR
                                ;THE LCD DISPLAY.

LCDTEXT EQU  $902A              ;ADDRESS OF AES ROUTINE WHICH SEND
                                ;TEXT STRING TO THE LCD DISPLAY.

;*********************************************************************



        ORG $100               ;Program starts in external RAM at 100Hex.

        JMP MAIN               ;jump to program 's main codes.

                               ;here is where N1*N1 will be stored
BUFFER  ZMB 14                 ;reserved 14 bytes of memory for storage.

                               ;ASCII string which represents
                               ;a first floating-point number.
N1      FCC '-1.343E-2'        ;N1 is in scientific notation.
        FCB 0                   

N2      FCC '-140'             ;ASCII string for a second
        FCB 0                  ;floating-point number.

MSG1    FCC 'N1*N2 ='          ;ASCII TEXT STRING for Display
        FCB 0
                               

        ORG $200                
MAIN:
                               ;program needs to convert the two
                               ;ASCII strings format to floating-point
                               ;format.


        LDX  #N1               ;set IX register to where N1 located.
        JSR  ASCFLT            ;convert N1 (the first number)
                               ;to FPACC1 by using JSR ASCFLT.


        JSR  TFR1TO2           ;Transfer N1 to FPACC#2

                               ;convert N2 to float. 
        LDX  #N2               
        JSR  ASCFLT            

        JSR  FLTMUL            ;multiply N1 and N2 together.
                               ;result is in FPACC#1



                               ;now, convert the floating-point
                               ;in FPACC1 to ASCII Format.

        LDX  #BUFFER           ;set IX to BUFFER
        JSR  FLTASC            ;float to ascii conversion

        LDX  #MSG1             ;output a prompt message to the CRT
        JSR  CRTTEXT           ;"N1*N2 ="

        JSR  LCDCLS            ;Clear the LCD Display.
        JSR  LCDTEXT           ;Send the same "N1*N2 =" text
                               ;to the LCD Display.


        LDX  #BUFFER           ;send result in ASCII Format
        JSR  CRTTEXT           ;to the CRT display.

        JSR  LCDTEXT           ;Send the result to the LCD Display also.
        
        RTS                    ;program ends and returns to the Debugger.

        END
