;IC2.ASM (AES11 PROGRAM)
;PROGRAM TO DETERMINE THE PERIOD OF A SQUARE WAVE CONNECTED
;TO PA1/IC2 pin

;SQUARE WAVE IS IN RANGE (20Hz -32KHz)

;Assembler: AS11 Ver. 1.03
;AS11.EXE LEDS.ASM
;To run program at debugger menu 's prompt:
;P 0100 <enter>


TCTL2   EQU     $21             ;TIMER CONTROL REGISTER 2
TFLG1   EQU     $23             ;MAIN TIMER INTERRUPT FLAG REGISTER 1
TIC2    EQU     $12             ;TIMER INPUT CAPTURE 2
        
        ORG     $100

        JMP     MAIN
        
        ORG     $200

FIRST   FDB    ;capture # of count of the timer counter on the 1st
               ;falling edge of the input wave

SECOND  FDB    ;capture # of count of the timer counter on the 2nd
               ;falling edge of the input wave

RESULT  FDB    ;difference between # of count
               ;this no. of count  times 1.085uS per count will give the 
               ;actual time in second for one period of the input 
               ;square wave
               
MAIN            
        LDX     #$6000          ;BASE ADDRESS OF I/O REGISTERS
        LDAA    #$8             ;EDG2B:EDG2A = 1:0; IC2 FALLING EDGES
        STAA    TCTL2,X 

        LDAA    #$2
        STAA    TFLG1,X         ;clear any old IC2F flag

LOOP1   BRCLR   TFLG1,X #$02 LOOP1    ;loop here until edge (IC2F set)


        LDD     TIC2,X          ;GET TIME OF FIRST EDGE
        STD     FIRST
        LDAA    #$2        
        STAA    TFLG1,X         ;clear IC2F flag by writing a one
                                ;to its corresponding bit position


LOOP2   BRCLR   TFLG1,X #$02 LOOP2      ;WAIT UNTIL SECOND EDGE

        LDD     TIC2,X          ;GET TIME OF SECOND
        STD     SECOND
        SUBD    FIRST
        STD     RESULT
        RTS                     ;return to the debugger
                                                           
        END
