;LCD01.ASM      (AES11 PROGRAM)
;program sends characters to the LCD display
;
;Assembler: AS11.EXE Ver 1.03
;Assembler Command Line: AS11 LCD01.ASM
;
;To run the program from the debugger menu:
;B 0100 <enter>

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;AES-11 ROM ROUTINES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LCDCLS  EQU     $9000    ;routine to clear the LCD display
LCDCHAR EQU     $9003    ;Send ASCII code in 6040h 
                         ;to the LCD display

SET_CUR EQU     $902D    ;routine to change the LCD 's cursor position
                         ;use the value in 6041H to set the cursor 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;AES-11 VARIABLES
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
AES_C   EQU     $6040    ;AES11 Monitor 's I/O Variable  
AES_LC  EQU     $6041    ;LCD Variable use to stored the
                         ;LCD 's cursor position number of (0-31d)
                                

        ORG     $100            ;program codes
        JSR     LCDCLS          ;clear the LCD display
        LDAA    #'A'            ;load A-accumulator with ASCII 'A'
        STAA    AES_C           ;store 'A' in location 6040h.
        JSR     LCDCHAR         ;local routine to send char in 6040h out
                                ;to the LCD display.
        
        INC     AES_C           ;increment the value at 6040H
        JSR     LCDCHAR         ;another char ('B') is sent to the LCD
        
        LDAA    #$10            ;new value to change LCD cursor position
                                ;10H (2nd row, 1st column)
        STAA    AES_LC          ;store 10H into 6041H
        JSR     SET_CUR         ;set the cursor on 2nd row, 1st column

        JSR     LCDCHAR         ;send ascii in AES_C to a new location(10H)
                                
        RTS                     ;program ends (return to the Debugger)



