;LEDS.ASM    (AES11 Sample Program)
;PROGRAM TO TOGGLE LEDS ON THE AES11 BOARD ON/OFF CONTINUEOUSLY. 
;
;Assembler: AS11 Ver. 1.03
;Assembler Commands: AS11 LEDS.ASM
;
;To run program at the Debugger Prompt, type
;B 0100 <enter>



;Address of HC11 I/O and control registers 
;(after remapped by the Debugger Program)

PORTA   EQU     $6000           ;PORT A DATA REGISTER
PORTD   EQU     $6008           ;PORT D DATA REGISTER
DDRD    EQU     $6009           ;PORT D DATA DIRECTION CONTROL REGISTER
        
        
        ORG $100                ;using the Debugger, the user program
                                ;address starts at 100 hex and up
                                ;user program can have up to 24K bytes
                                ;of codes

        LDAA #$FF             ;Load A-accumulator with FFh
        STAA DDRD             ;write FFH will setup PORT D Data Register for
                              ;output port

MAIN
        CLRA                  ;clear A-accumulator
        STAA PORTD            ;toggle PD5,PD4,PD3,PD2 pins low
                              ;(write zeros to the above port D pins 
                              ; will light up the four upper LEDs)
        
        STAA PORTA            ;toggle PA5,PA6 pins low (light up
                              ;the last two LEDS )
        
        LDX #$FFFF            ;
LOOP1   DEX                   ;Delays (64K x 3 x 3 ) machine cycles
        BNE LOOP1

        LDAA #$FF           
        STAA PORTD           ;toggle PD5,PD4,PD3,PD2 high (LEDs OFF)
        LDAA #$E7            ;toggle PA5,PA6 high (LEDs OFF)
        STAA PORTA

        LDX #$FFFF
LOOP2   DEX                  ;Delays (64K x 3 x 3) machine cycles again
        BNE LOOP2
        
        JMP MAIN
                





