;SCI.ASM (AES11 PROGRAM
;
;program reads one character from the serial port and sends its back
;to the serial port
;
;Assembler: AS11 Ver. 1.03
;Assembler Commands: AS11 SCI.ASM
;
;To run the program at the debugger prompt:
;B 0100 <enter>


;ADDRESS OF I/O and control registers (after remapped)

SCSR    EQU     $602E           ;SCI Status Register
SCDR    EQU     $602F           ;SCI Data Register

        ORG     $100
        
        
        PSHA                    ;save A,B accumulators
        PSHB

T       LDAB SCSR               ;read SCI Status Register
        BITB #$20               ;is character has been received? (RDRF=1)
        BEQ  T                  ;not yet, loop again
        LDAA SCDR               ;get character from SCDR
                                

T2      LDAB SCSR               ;read status register
        BITB #$80               ;wait for TDRE=1, transmit ready
        BEQ T2

        STAA SCDR               ;send character in A Register to serial
                                ;port
                                
        PULB                    ;restore A and B accumulator
        PULA                    
        RTS
