;STEP.ASM
;program uses PORT D output 's pins 5,4,and 3 to drive the step motor
;
;use pin channels - since all channels are inverted and therefore
;drive states are also inverted
;ON/OFF Port D pin 5    L=ON, H=OFF
;CW/CCW Port D pin 4    L=CW, H=CCW
;DRIVE  Port D pin 3    L=Pulse Drive


PORTA   EQU     $6000           ;PORT A DATA REGISTER
PORTD   EQU     $6008           ;PORT D DATA REGISTER
DDRD    EQU     $6009           ;PORT D DATA DIRECTION CONTROL REGISTER

        ORG     $100

        LDAA #$FF
        STAA DDRD             ;SETUP PORT D FOR OUTPUT
        LDAA #%00101000       ;
        STAA PORTD            ;Motor off, Clockwise rotation, pulse off
        
STEADY:
        LDX     #$9C40        ;value for 40K pulse /minute
PX
        JSR    PULSE          ;make pulse high (
        JSR    DELTA          ;make pulse low (1.5ms)  
        DEX    
        BNE    PX 
        RTS

;pulse the motor, will give a pulse of 21 machine cycles
;which is equal 

PULSE   LDAB    #$3
        LDAA    #%00000000
CT
        STAA    PORTD           ;Toggle pulse high , 4 cycles
        DECB                    ;2 cycles
        BNE     CT              ;3 cycles
        LDAA    #%00001000      ;turn off pulse
        STAA    PORTD
        RTS                     ;5 machine cycles

;make a delay of 1.5ms between each pulse
DELTA   PSHY            ;5 cycles
        
        LDY     #$C0    ; C0 x 7 x 1.085uS = 1.477mS
CT2
        DEY             ;4 cycles
        BNE     CT2     ;3 cycles
        PULY            ;6 cycles
        RTS             ;5 cycles
        END



