1  REM 8255.BAS (AES11 EXAMPLE PROGRAM FOR THE P-10 BOARD)
5  REM Program tests an 8255 connected to the AES-11 through the
8  REM P-10 Project Board and jumper J1. The 8255 chip is used to 
10 REM create three extra 8-pin ports in 8-bit control systems.
13 REM
20 REM program reads data from PORTA of the 8255 and writes data out
30 REM to both PORTB & PORTC on the 8255.

40 REM 8255 's PORTA is configured as input port.          
50 REM 8255 's PORTB & PORTC are configured as output port.

60 REM To test PORTA for input port, tight any PORTA ' s pins to 5V+ or GND
70 REM and use a logic probe to test the output on PORTB and PORTC.

80 REM ADDRESSES on the AES11 system which addressing the 8255's ports.
90 REM 
100 REM REGISTER NAME           HARDWARE ADDRESSES
110 REM 8255's PORTA            7000Hex
120 REM 8255's PORTB            7001Hex
130 REM 8255's PORTC            7002Hex
140 REM 8255's Control Register 7003Hex

200 POKE($7003,$90)     : REM configure the 8255 's Control Register
210 REM                   set PORTA for input; PORTB & PORTC for output

220 X=PEEK($7000)       : REM now read input from PORTA

230 POKE($7001,X)       : REM write read result from PORTA to
240 POKE($7002,X)       : REM to PORTB and PORTC
250 END





