/* demo11.c                                                                
   program displays a menu with some test programs to run on the aes11 board.

   compiler command:
   icc11 -o demo11 demo11.c aes11.s printf.s printf2.s                    

   aes11.s printf.s printf2.s are precompiled assembly codes from C programs

   The compiler will create a motorola hex file, demo11.s19
   Download the demo11.s19 onto the aes11 board, and type B 0100
   at the Debugger Prompt to execute the program
*/ 

void main()
{       
        int _N;        
        char x;

        while (x != 'Q') {
        
        NEWLINE();
        printf("%s","1. Toggle LEDs on");  NEWLINE();
        printf("%s","2. Toggle LEDs off"); NEWLINE();
        printf("%s","3. Clear the LCD display"); NEWLINE();
        printf("%s","4. Send message to the LCD display"); NEWLINE();
        printf("%s","5. Read A/D conversion at PE.0    "); NEWLINE();
        printf("%s","6. Read the hardware scancode on the keypad"); NEWLINE();
        printf("%s","7. Make D/A conversion at DA OUT (send 7Fh)"); NEWLINE();
        printf("%s","8. Make D/A conversion at DA OUT (send FFh)"); NEWLINE();

        printf("%s","Q. Quit"); NEWLINE(); NEWLINE();
        printf("%s","Selection? ");
        
        x=GETCHAR();    /* get user selection */

        NEWLINE();

        switch(x)
        {
        
        case '1': {
                    LEDS_ON();          /* call function to toggle LEDs ON */
                    break;
                   }

         case '2': {                
                    LEDS_OFF();         /* toggle LEDs on board off     */
                    break;
                    }

         case '3':
                    {
                    LCDCLEAR();         /* clear the LCD display        */
                    break;
                    }

         case '4':
                    {
                    LCDCLEAR();                  /* clear the LCD display */
                    printf2("%s","Hello World"); 
                    break;
                    }


         case '5':
                    {
                    _N = ADC();         /* read A/D */
                    NEWLINE();
                    printf("%s%x%s","A/D reading = ",_N," * 19.37mV");
                    NEWLINE();
                    break;
                    }

         case '6':
                    {
                    NEWLINE();
                    printf("%s","Please press any key on the keypad");
                    _N = KEYCODE();  /* read hardware keycode */
                    NEWLINE();
                    printf("%s%x","hardware scancode = ",_N);
                    NEWLINE();
                    break;
                    }

         case '7':  {
                    DAC(0x7F);
                    NEWLINE();
                    printf("%s","D/A Conversion Done");
                    NEWLINE();
                    break;
                    }

         case  '8': {
                    DAC(0xFF);
                    NEWLINE();
                    printf("%s","D/A Conversion Done");
                    NEWLINE();
                    break;
                    }

         default:   {
                    break;
                    }
        
        } /* end switch */
        
        } /* end while */

}/* end main */



