;BAUDR.ASM                               
;ROM PROGRAM TO SEND CHARACTER 'H' INFINITELY TO THE CRT DISPLAY
;
;Assembler: AS11 Ver. 1.03
;AS11.EXE BAUDR.ASM

                               ; AES11 DEVICE ADDRESS 
SCIDRR  EQU $7500              ; TO DISABLE 2ND SERIAL PORT
                               ; Y5/ output on the decoder



;ADDRESS OF HC11 I/O registers (DEFAULT ADDRESS)

SCSR    EQU     $102E           ;SCI Status Register
SCDR    EQU     $102F           ;SCI Data Register
BAUD    EQU     $102B           ;SCI BAUD RATE CONTROL REGISTER
SCCR2   EQU     $102D           ;SCI CONTROL REGISTER 2

        
        ORG     $8000          ;AES11 ROM CODES START AT $8000
        
                               ;Write out anything to
        STA  SCIDRR            ;DISABLE 2nd SERIAL PORT ON THE AES11 
                               ;SYSTEM (important: A MUST inorder
                               ;for the 1st SERIAL PORT to
                               ;communicate with the PC PORT )

            
       LDAA #$11           ;AES11, 3.6864Mhz 
       STAA BAUD           ;9600B, N,8,1
       LDAA #$0C
       STAA SCCR2          ;Enable Transmit/Receive Ready


T       LDAB SCSR          ;read status register
        BITB #$80          ;wait for TDRE=1, transmit ready
        BEQ T
        LDAA #'H'
        STAA SCDR          ;send 'H' to Data Register

        BRA T              ;send 'H' again

        ORG     $FFFE      ;reset vector when uP reset
RESET   FDB     $8000           
